/*
								+---------------------------------+
								|                                 |
								|        ***   Main   ***         |
								|                                 |
								|  Copyright   -tHE SWINe- 2002  |
								|                                 |
								|            Main.cpp             |
								|                                 |
								+---------------------------------+
*/

#include <windows.h>
#include <malloc.h>
#include <stdio.h>
#include <math.h>

#include "Directx.h"
#include "Matrix.h"
#include "Load_3ds.h"
#include "Raster.h"
#include "Main.h"


#define APPNAME "3D_Engine_04"
#define WNDNAME "3D_Engine_04 - raster test"
static int Width = 512;
static int Height = 384;

unsigned __int32 *video;
unsigned __int32 *buffer;

#define PI 3.1415926

static World *svet;
static Matrix cmatrix;

int WINAPI WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance, PSTR szCmdline, int nCmdShow)
{
	WNDCLASSEX wndclass;
	char szAppName[] = APPNAME;
	HWND hwnd;
	MSG msg;

	wndclass.cbSize			= sizeof(wndclass);
	wndclass.style			= CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc	= Wokno;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;
	wndclass.hInstance		= hInstance;
	wndclass.hIcon			= LoadIcon(hInstance, IDI_APPLICATION);
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName	= 0;
	wndclass.lpszClassName	= szAppName;
	wndclass.hIconSm		= LoadIcon(NULL, IDI_APPLICATION);
	RegisterClassEx(&wndclass);
	hwnd = CreateWindow(szAppName,
		WNDNAME, WS_DLGFRAME,
		CW_USEDEFAULT, CW_USEDEFAULT,
		Width, Height,
		NULL, NULL,	hInstance, NULL);
	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);
	// create window ...

	ShowCursor(FALSE);
	// hide mouse

	Matrix_Init(&cmatrix);
	Matrix_Rotate_Z(&cmatrix, (float)-PI);
	Matrix_Rotate_X(&cmatrix, (float)-PI / 6);
	Matrix_Translate(&cmatrix, 0, 0, -120);
	// camera ok

	static int i;
	if((svet = Load_3DS("object.3ds")) == NULL)
		return 0;
	for(i = 0; i < svet->n_object_num; i ++)
		Matrix_Init(&svet->object[i].m_object);
	// svet ok

	Init_Engine(Width, Height);
	// prepare rasterizer

	if((buffer = (unsigned __int32*) malloc(Width * Height * 4)) == NULL)
		return 0;
	// alloc framebuffer

	SetTimer(hwnd, 0, 20, NULL);
	// set timer

	InitDirectX(hwnd, Width, Height);
	// init directX

	while(GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	TerminateDirectX();
	free((void*)buffer);
	Terminate_Engine();
	// uvoln pam

	ShowCursor(TRUE);
	// obnov kurzor

	return msg.wParam;
}

LRESULT CALLBACK Wokno (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	static float a = 0;
	int i;

	switch(iMsg) {
	case WM_KEYDOWN :
		if(wParam == VK_ESCAPE) {
			SendMessage(hwnd, WM_CLOSE, 0, 0);
			return 0;
		}
		return 0;

	case WM_TIMER :
		memset(buffer, 0, 4 * Width * Height);
		// clean screen ...

		a += (float)0.05;
		if(a > 6.28)
			a = 0;
		// angle ...

		for(i = 0; i < svet->n_object_num; i ++) {
			Matrix_Rotate_X(&svet->object[i].m_object, (float)PI / 100);
			Matrix_Rotate_Y(&svet->object[i].m_object, (float)PI / 100 * (float)sin(a));
			DrawObject(&svet->object[i].m_object, &cmatrix, &svet->object[i], buffer, 0xfa8008);
		}
		// draw and rotate objects ...

		if(InitVideoBuffer(&video)) {
			memcpy(video, buffer, 4 * Width * Height);
			// copy image ...
		
			FlipVideoBuffer();
		}

		return 0;

	case WM_DESTROY:
		PostQuitMessage (0);
		return 0;
	}
	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
}





